import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ShopOrderGoods, ShopOrderGoodsParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商品信息
 */
export async function pageShopOrderGoods(params: ShopOrderGoodsParam) {
  const res = await request.get<ApiResult<PageResult<ShopOrderGoods>>>(
    MODULES_API_URL + '/shop/shop-order-goods/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品信息列表
 */
export async function listShopOrderGoods(params?: ShopOrderGoodsParam) {
  const res = await request.get<ApiResult<ShopOrderGoods[]>>(
    MODULES_API_URL + '/shop/shop-order-goods',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品信息
 */
export async function addShopOrderGoods(data: ShopOrderGoods) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-order-goods',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品信息
 */
export async function updateShopOrderGoods(data: ShopOrderGoods) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-order-goods',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品信息
 */
export async function removeShopOrderGoods(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-order-goods/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品信息
 */
export async function removeBatchShopOrderGoods(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/shop-order-goods/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品信息
 */
export async function getShopOrderGoods(id: number) {
  const res = await request.get<ApiResult<ShopOrderGoods>>(
    MODULES_API_URL + '/shop/shop-order-goods/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
